AOZ Studio Beta - Bug #399

Gosub and Goto using variable fails (integer or string)
06/27/2020 01:13 AM - Brian Flanagan

Status: Closed Start date: 06/27/2020
Priority: High Due date:

Assignee: Francois Lionet % Done: 0%
Category: Estimated time: 2:00 hours
Target version: Beta RC4

Affected version: Beta RC2

Description

Gosub using variable fails. (related to bug #28)
The result is a syntax error.

#manifest: "pc"
#splashScreen: false
#speed: "safe"

#fps: false

X=20
Gosub X
End

20 Print "line 20"
Return

This also fails when using labels:

#manifest: "pc"
#splashScreen: false
#speed: "safe"

#fps: false

X=20
X$="MyLabel"
Gosub X$
End

MyLabel:
Print "My Label"
Return

NOTE: In both cases, you can work around this bug by putting the expression within parentheses, but this should NOT be required.
Any valid expression should be allowed.

NOTEZ2: This was also a bug in AMOOS Pro (for numerics). String expressions weren't a problem in AMOS Pro (but they are in
AOZ!).

Here's the syntax description from the manual... as it should be:

GOSuUB

structure: jump to a sub-routine
Gosub label

Gosub number

Gosub expression

NOTE that there are NO parentheses in the syntax!
NOTE also that string labels are NOT case-sensitive!

History
http://support.aoz.studio/issues/28

#1 - 06/27/2020 04:26 PM - Brian Flanagan
- Affected version changed from 0.9.9.2 to 0.9.9.3

Corrected affected version.

#2 - 09/14/2020 12:52 PM - Laurant Weill
- Priority changed from Normal to High

#3 - 09/19/2020 08:22 AM - Brian Flanagan
- Estimated time set to 2:00 h
- Affected version changed from 0.9.9.3 to Beta RC2

Re-tested in Beta RC2. Both examples still fail.

#4 - 10/07/2020 08:57 AM - Francois Lionet
- Status changed from New to Resolved
- Assignee set to Francois Lionet

- Target version set to Beta RC4

Fixed!

#5 - 10/09/2020 02:12 PM - Brian Flanagan

- Status changed from Resolved to Closed

Works with 9 Oct updates!
